workflow jellyfish{
    String prefix 
    Int k
    Int nCPUs
    Array[File] fastqs
    call k_mer_for_gz_file { 
        input: 
            prefix = prefix,
            k = k,
            nCPUs = nCPUs,
            fastqs = fastqs
    }
}

task k_mer_for_gz_file{
    String prefix 
    Int k
    Int nCPUs
    Array[File] fastqs
		String files = sep(') ', prefix('<(zcat ', fastqs)) + ")"
    command {
    /BioBin/jellyfish-1.1.11/bin/jellyfish count -m ${k} -t ${nCPUs} -o ${prefix} -s 25G --timing ${prefix}.timing  --stats ${prefix}.stats ${files} 
    /BioBin/jellyfish-1.1.11/bin/jellyfish histo ${prefix}_* > ${prefix}.histo 
    }
    runtime {
        docker :"jellyfish:1.1.11";
        cpu : nCPUs ;
        memory : "3G";
				resourcescale : "auto"
        disableoom: true
    }
}



task k_mer_for_fastqs {
    String prefix 
    Int k
    Int nCPUs
    Array[File] fastqs

    command {
    /BioBin/jellyfish-1.1.11/bin/jellyfish count -m ${k} -t ${nCPUs} -o ${prefix} -s 25G --timing ${prefix}.timing  --stats ${prefix}.stats ${sep=" " fastqs}
    /BioBin/jellyfish-1.1.11/bin/jellyfish histo  ${prefix}_0 > ${prefix}.histo 
    }
    runtime {
        docker :"jellyfish:1.1.11";
        cpu : nCPUs ;
        memory : "3G";
				resourcescale : "auto"
        disableoom: true
    }
}
